"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatInputValues = exports.getColors = exports.high = exports.low = void 0;
const constants_js_1 = require("../constants.js");
const gradientParser_js_1 = require("./gradientParser.js");
const { defaultColor, defaultGradient } = constants_js_1.config;
const low = (color) => {
    return color.value.toLowerCase();
};
exports.low = low;
const high = (color) => {
    return color.value.toUpperCase();
};
exports.high = high;
const getColors = (value) => {
    let isGradient = value?.includes('gradient');
    if (isGradient) {
        let isConic = value?.includes('conic');
        let safeValue = !isConic && validate(value) ? value : defaultGradient;
        if (isConic) {
            console.log('Sorry we cant handle conic gradients yet');
        }
        var obj = (0, gradientParser_js_1.gradientParser)(safeValue);
        return obj?.colorStops;
    }
    else {
        let safeValue = validate(value) ? value : defaultColor;
        return [{ value: safeValue }];
    }
};
exports.getColors = getColors;
let validate = (c) => {
    // let img = window?.document?.createElement('img')
    // img.style = 'background: rgb(0, 0, 0)'
    // img.style = 'background: ' + c
    // if (img.style.background !== 'rgb(0, 0, 0)' && img.style.background !== '')
    //   return true
    // img.style = 'background: rgb(255, 255, 255)'
    // img.style = 'background: ' + c
    // return (
    //   img.style.background !== 'rgb(255, 255, 255)' && img.style.background !== ''
    // )
    return true;
};
const formatInputValues = (value, min, max) => {
    return isNaN(value) ? min : value < min ? min : value > max ? max : value;
};
exports.formatInputValues = formatInputValues;
